'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class; /**
             * Created by tonyjiang on 16/3/14.
             */


var _interface = require('../interface');

var _interface2 = _interopRequireDefault(_interface);

var _chanjetPluginBase = require('chanjet-plugin-base');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var GeoPluginChanjet = (0, _chanjetPluginBase.ChanjetDecorator)(_class = function (_GeoPlugin) {
    _inherits(GeoPluginChanjet, _GeoPlugin);

    function GeoPluginChanjet() {
        _classCallCheck(this, GeoPluginChanjet);

        var _this = _possibleConstructorReturn(this, (GeoPluginChanjet.__proto__ || Object.getPrototypeOf(GeoPluginChanjet)).call(this));

        _this.pluginName = 'Location';
        _this.methodName = {
            getLocation: 'getLocation',
            displayNearby: 'displayNearby'
        };
        return _this;
    }

    _createClass(GeoPluginChanjet, [{
        key: 'getLocation',
        value: function getLocation() {
            var callback = arguments.length <= 0 || arguments[0] === undefined ? function () {} : arguments[0];
            var requestId = arguments.length <= 1 || arguments[1] === undefined ? '' : arguments[1];


            cordova.exec(this._getLocationSuccessHandler.bind(this, callback, requestId), this._getLocationFailedHandler.bind(this, callback, requestId), this.pluginName, this.methodName.getLocation, []);
        }
    }, {
        key: '_getLocationSuccessHandler',
        value: function _getLocationSuccessHandler(callback, requestId, rs) {
            var rsJSON = JSON.parse(rs);

            var resultCode = rsJSON.code == 0 ? 0 : 1;
            var message = rsJSON.code == 0 ? rsJSON.msg : JSON.parse(rsJSON.msg);

            //获取位置成功后, 将坐标转换成float
            if (resultCode == 0) {
                rsJSON.data.latitude = parseFloat(rsJSON.data.latitude);
                rsJSON.data.longitude = parseFloat(rsJSON.data.longitude);
            }

            var result = {
                resultCode: resultCode,
                message: message,
                requestId: requestId,
                body: {
                    data: rsJSON.data
                }
            };

            callback(result);
        }
    }, {
        key: '_getLocationFailedHandler',
        value: function _getLocationFailedHandler(callback, requestId, error) {
            var errorJSON = JSON.parse(error);

            var rs = {
                resultCode: 1,
                message: errorJSON.msg,
                requestId: requestId,
                body: {
                    data: errorJSON.data
                }
            };
            callback(rs);
        }
    }, {
        key: 'displayNearby',
        value: function displayNearby(options) {
            var callback = arguments.length <= 1 || arguments[1] === undefined ? function () {} : arguments[1];
            var requestId = arguments.length <= 2 || arguments[2] === undefined ? '' : arguments[2];


            cordova.exec(this._displayNearbySuccessHandler.bind(this, callback, requestId), this._displayNearbyFailedHandler.bind(this, callback, requestId), this.pluginName, this.methodName.displayNearby, [options]);
        }
    }, {
        key: '_displayNearbySuccessHandler',
        value: function _displayNearbySuccessHandler(callback, requestId, rs) {
            var rsJSON = JSON.parse(rs);

            var resultCode = rsJSON.code == 0 ? 0 : 1;
            var message = rsJSON.code == 0 ? rsJSON.msg : JSON.parse(rsJSON.msg);

            //获取位置成功后, 将坐标转换成float
            if (resultCode == 0) {
                rsJSON.data.latitude = parseFloat(rsJSON.data.latitude);
                rsJSON.data.longitude = parseFloat(rsJSON.data.longitude);
            }

            var result = {
                resultCode: resultCode,
                message: message,
                requestId: requestId,
                body: {
                    data: rsJSON.data
                }
            };

            callback(result);
        }
    }, {
        key: '_displayNearbyFailedHandler',
        value: function _displayNearbyFailedHandler(callback, requestId, error) {
            var errorJSON = JSON.parse(error);

            var rs = {
                resultCode: 1,
                message: errorJSON.msg,
                requestId: requestId,
                body: {
                    data: errorJSON.data
                }
            };
            callback(rs);
        }
    }]);

    return GeoPluginChanjet;
}(_interface2.default)) || _class;

exports.default = GeoPluginChanjet;