/**
 * Created by tonyjiang on 16/3/14.
 */
import GeoPlugin from '../interface'
import {ChanjetDecorator} from 'chanjet-plugin-base'

@ChanjetDecorator
class GeoPluginChanjet extends GeoPlugin{

    constructor(){
        super();

        this.pluginName = 'Location';
        this.methodName = {
            getLocation : 'getLocation',
            displayNearby : 'displayNearby'
        };
    }

    getLocation(callback = () => {} , requestId = ''){

        cordova.exec(
            this._getLocationSuccessHandler.bind(this , callback , requestId),
            this._getLocationFailedHandler.bind(this , callback , requestId),
            this.pluginName , this.methodName.getLocation , []
        )


    }

    _getLocationSuccessHandler(callback , requestId , rs){
        const rsJSON = JSON.parse(rs);

        const resultCode = rsJSON.code == 0 ? 0 : 1;
        const message = rsJSON.code == 0 ? rsJSON.msg : JSON.parse(rsJSON.msg);

        //获取位置成功后, 将坐标转换成float
        if(resultCode == 0){
            rsJSON.data.latitude = parseFloat(rsJSON.data.latitude);
            rsJSON.data.longitude = parseFloat(rsJSON.data.longitude);
        }

        const result = {
            resultCode : resultCode,
            message : message,
            requestId : requestId,
            body : {
                data : rsJSON.data
            }
        }

        callback(result);
    }

    _getLocationFailedHandler(callback , requestId , error){
        const errorJSON = JSON.parse(error);

        const rs = {
            resultCode : 1,
            message : errorJSON.msg,
            requestId : requestId,
            body : {
                data : errorJSON.data
            }
        };
        callback(rs);
    }

    displayNearby(options , callback = () => {} , requestId = ''){

        cordova.exec(
            this._displayNearbySuccessHandler.bind(this , callback , requestId),
            this._displayNearbyFailedHandler.bind(this , callback , requestId),
            this.pluginName , this.methodName.displayNearby , [options]
        );

    }

    _displayNearbySuccessHandler(callback , requestId , rs ){
        const rsJSON = JSON.parse(rs);

        const resultCode = rsJSON.code == 0 ? 0 : 1;
        const message = rsJSON.code == 0 ? rsJSON.msg : JSON.parse(rsJSON.msg);

        //获取位置成功后, 将坐标转换成float
        if(resultCode == 0){
            rsJSON.data.latitude = parseFloat(rsJSON.data.latitude);
            rsJSON.data.longitude = parseFloat(rsJSON.data.longitude);
        }

        const result = {
            resultCode : resultCode,
            message : message,
            requestId : requestId,
            body : {
                data : rsJSON.data
            }
        }

        callback(result);
    }

    _displayNearbyFailedHandler(callback , requestId , error ){
        const errorJSON = JSON.parse(error);

        const rs = {
            resultCode : 1,
            message : errorJSON.msg,
            requestId : requestId,
            body : {
                data : errorJSON.data
            }
        };
        callback(rs);
    }

}

export default GeoPluginChanjet